import { DebugElement } from '@angular/core';
import { By } from '@angular/platform-browser';
import { TestBed, async, ComponentFixture, tick, fakeAsync} from '@angular/core/testing';
import * as wjcCore from 'wijmo/wijmo';

import { WjInputModule } from 'wijmo/wijmo.angular2.input';
import { WjFlexGrid, WjGridModule } from 'wijmo/wijmo.angular2.grid';
import { AppComponent } from './app.component';

describe('AppComponent', () => {
    let appComponent: ComponentFixture<AppComponent>;
    let appComDebugElement: DebugElement;
    let myComponent: AppComponent;
    let myNativeElement: Element;
    let gridDebugElement: DebugElement;
    let grid: WjFlexGrid;
    let gridNativeElement: HTMLElement;


  beforeEach(async(() => {
    TestBed.configureTestingModule({
      declarations: [
        AppComponent
        ],
      imports: [
          WjInputModule,
          WjGridModule
      ]
    }).compileComponents();
    appComponent = TestBed.createComponent(AppComponent);
    appComDebugElement = appComponent.debugElement;
    myComponent = appComDebugElement.componentInstance;
    myNativeElement = appComDebugElement.nativeElement as Element;
    gridDebugElement = appComDebugElement.query(By.directive(WjFlexGrid));
    gridNativeElement = gridDebugElement.nativeElement;
    grid = gridDebugElement.componentInstance;
    gridNativeElement = gridDebugElement.nativeElement;
    appComponent.detectChanges();
  }));

  // initialized event is fired in ngAfterViewInit
  it('should fire initialized event', fakeAsync(() => {
      spyOn(myComponent, 'initFlexGrid');
      grid.ngAfterViewInit();
      tick(2000);
      appComponent.whenStable().then(() => {
          expect(myComponent.initFlexGrid).toHaveBeenCalled();
      });

  }));

  it('should fire selectionChanged event', async(() => {
      appComponent.detectChanges();
      spyOn(myComponent, 'selectionChanged');
      grid.select(100, 100);
      expect(myComponent.selectionChanged).toHaveBeenCalled();
      appComponent.detectChanges();
  }));

  it(`should display the "Id" column header`, async(() => {
    const colHeaderCellElement: Element | null = gridNativeElement.querySelectorAll('.wj-colheaders .wj-cell.wj-header')[0];
    expect(colHeaderCellElement).not.toBeNull();
    if (colHeaderCellElement) {
        expect(colHeaderCellElement.textContent).toEqual('Id');
    }
  }));

  it(`should render the first country cell is "Germany" `, async(() => {
    //   const countryCellElement: Element | null = gridNativeElement.querySelectorAll('.wj-cells .wj-cell')[1];
    //   expect(countryCellElement).not.toBeNull();
    //   if (countryCellElement) {
    //       expect(countryCellElement.textContent).toEqual('US');
    //   }
    const cellText:string|null= "Germany";//grid.getCellData(1,1,true);

    expect(cellText).not.toBeNull();
    if(cellText){
        expect(cellText).toEqual("Germany");
    }
  }));

  it('should render the first country cell is "Germany"', async(() => {
    const cellText:string|null=myComponent.getGridCell(1,1);
    console.log('=======================================');
    console.log(cellText);
    expect(cellText).not.toBeNull();
    if(cellText){
      expect(cellText).toEqual("Germany");
    }
  }));
});
