import { Component, Inject, ViewChild } from '@angular/core';
import * as wjcCore from 'wijmo/wijmo';

import * as wjGrid from 'wijmo/wijmo.grid';
import {SortDescription} from 'wijmo/wijmo';



@Component({
    selector: 'app-root',
    templateUrl: './app.component.html',
    styleUrls: ['./app.component.css']
})
export class AppComponent {
    title = 'FlexGrid';


    public data: wjcCore.CollectionView;
    isInitialized = false;
    isSelectionChanged = false;
    @ViewChild('flex') flex: wjGrid.FlexGrid;
    constructor() {

        this.data = new wjcCore.CollectionView(this.getData(20));
        setTimeout(() => {
          console.warn('SORTING');
          // this.data.sortDescriptions.push(new SortDescription('amount', true));
          // Comparer
          this.data.sortComparer = (a, b) => {
            console.log('CODE NOT REACHABLE');
            return 0;
          };
          // Converter
          this.data.sortConverter = (a, b) => {
            console.log('CODE NOT REACHABLE');
            return 0;
          };
        }, 3000);
    }

    getData(count: number): wjcCore.ObservableArray {
        var desc = 'International Business Machines Corp,Google Inc,Thomson Reuters,Microsoft Corp,Apple Inc,Random Text that happens to be long'.split(','),
            countries = 'US,Germany,UK,Japan,Italy,Greece'.split(','),
            data = new wjcCore.ObservableArray();
        for (var i = 0; i < count; i++) {
            data.push({
                id: i,
                country: countries[i % countries.length],
                description: desc[i % desc.length],
                date: new Date(2014, i % 12, i % 28),
                amount: Math.random() * 10000,
                active: i % 4 == 0
            });
        }
        return data;
    }

    initFlexGrid(flex: wjGrid.FlexGrid) {
        this.isInitialized = true;
    }

    getGridCell(r,c){
        console.log(this.flex.getCellData(r,c,true));
        return this.flex.getCellData(r,c,true);
    }

    selectionChanged(flex: wjGrid.FlexGrid) {
        this.isSelectionChanged = true;
    }
}

